import { Initializer } from '@azure-tools/codegen';
export declare type fIterable<T> = Iterable<T> | (() => Iterable<T>);
export interface Statement {
    implementation: string;
}
export declare type StatementOrLiteral = Statement | string;
export declare type OneOrMoreStatements = StatementOrLiteral | fIterable<StatementOrLiteral | undefined>;
export declare type OneOrMoreStatements2 = OneOrMoreStatements | fIterable<OneOrMoreStatements | undefined>;
export declare type OneOrMoreStatements3 = OneOrMoreStatements2 | fIterable<OneOrMoreStatements2 | undefined>;
export declare type OneOrMoreStatements4 = OneOrMoreStatements3 | fIterable<OneOrMoreStatements3 | undefined>;
export declare type OneOrMoreStatements5 = OneOrMoreStatements4 | fIterable<OneOrMoreStatements4 | undefined>;
export declare type StatementPossibilities = OneOrMoreStatements5 | Statements | undefined;
export declare function toStatement(statement: StatementOrLiteral): Statement;
export declare function isStatement(object: StatementPossibilities): object is Statement;
export declare class Statements extends Initializer implements Statement {
    protected statements: Statement[];
    private scope;
    constructor(statements?: StatementPossibilities, objectIntializer?: Partial<Statements>);
    push(innerScope: Statements): Statements | undefined;
    pop(): Statements | undefined;
    get count(): number;
    insert(statements: StatementPossibilities): Statements;
    add(statements: StatementPossibilities): Statements;
    get implementation(): string;
}
export declare function BlockStatement(statements: StatementPossibilities): Generator<string, void, unknown>;
//# sourceMappingURL=statement.d.ts.map